#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "ui_mainwindow.h"

#include <marketplace.h>

#include <QMainWindow>

#include <memory>

class MainWindow : public QMainWindow
{
    Q_OBJECT

  public:
    MainWindow();
    Marketplace* getMarketplace() { return marketplace_.get(); }

  private slots:
    void onBasketViewSelectionChanged(const QItemSelection& selected,
                                      const QItemSelection& deselected);
    void onSalesViewSelectionChanged(const QItemSelection& selected,
                                     const QItemSelection& deselected);
    void onCancelArticleButtonClicked(bool checked);
    void onCancelSaleButtonClicked(bool checked);
    void onPrintSaleReceiptButtonClicked(bool checked);
    void onCancelAllArticlesButtonClicked(bool checked);
    void onAboutQt();
    void onAbout();

  private:
    void onActionEditSellerTriggered();
    void onSellerNoEditCheckSellerNo();
    void onPaidButtonTriggered();
    void onImportSellerExcelActionTriggered();
    void onImportSellerJsonActionTriggered();
    void onExportSellerJsonActionTriggered();
    void onExportSalesJsonActionTriggered();
    void onImportSalesJsonActionTriggered();
    void setSaleModel();

    Ui::MainWindow ui_;
    std::unique_ptr<Marketplace> marketplace_;
};

#endif